package com.logicbig.example;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

@Service
@CacheConfig(cacheNames = "employee-cache")
public class EmployeeService {

    @Cacheable
    public String[] getDepartments() {
        System.out.println("getDepartments() invoked");
        return new String[]{"IT", "Admin", "Account"};
    }

    @Cacheable
    public Employee getEmployeeById(int id) {
        System.out.println("getEmployeeById() invoked");
        return new Employee(id, "Adam", "IT");
    }

    @Cacheable
    public Employee getEmployeeByNameAndDept(String name, String dept) {
        System.out.println("getEmployeeByNameAndDept() invoked");
        return new Employee(20, name, dept);
    }
}