package com.logicbig.example;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

@Service
@CacheConfig(cacheNames = "employee-cache")
public class EmployeeService2 {

    @Cacheable
    public String[] getDepartments() {
        System.out.println("getDepartments() invoked");
        return new String[]{"IT", "Admin", "Account"};
    }

    @Cacheable(key = "#root.methodName")
    public Employee[] getAllEmployees() {
        System.out.println("getAllEmployees() invoked");
        return new Employee[]{new Employee(30, "Joe", "Account")};
    }
}