package com.logicbig.example;

import org.springframework.cache.Cache;
import org.springframework.cache.CacheManager;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;


public class ExampleMain {

    public static void main(String[] args) {
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(AppConfig.class);
        EmployeeService employeeService = context.getBean(EmployeeService.class);

        System.out.println("-- getting dept list --");
        String[] depts = employeeService.getDepartments();
        System.out.println("depts returned: "+depts);

        System.out.println("-- getting employee by id --");
        Employee employee = employeeService.getEmployeeById(10);
        System.out.println("employee returned: "+employee);

        System.out.println("-- getting employee by name and dept --");
        Employee employee2 = employeeService.getEmployeeByNameAndDept("Linda", "Admin");
        System.out.println("employee returned: "+employee2);

        System.out.println("-- printing native cache --");
        CacheManager cm = context.getBean(CacheManager.class);
        Cache cache = cm.getCache("employee-cache");
        System.out.println(cache.getNativeCache());
    }
}